package com.gic.haoban.manage.web.controller;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.PageResult2;
import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.dto.MaterialCategoryDTO;
import com.gic.haoban.manage.api.dto.MaterialDTO;
import com.gic.haoban.manage.api.service.MaterialApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.vo.MaterialVO;

@RestController
public class MaterialController extends WebBaseController{
	
	@Autowired
	private MaterialApiService materialApiService;
	/**
     * 素材查询
     * @return
     */
    @RequestMapping("/material-list")
    public HaobanResponse materialList(String wxEnterpriseId,String keyword,String categoryId,Integer materialType,BasePageInfo pageInfo) {
    	Page<MaterialDTO> page = materialApiService.listMaterial(wxEnterpriseId,keyword,categoryId,materialType,pageInfo);
    	 //暂时转换
        PageResult2 pageResult2 = PageUtil.getPageInfo(page);
        return resultResponse(HaoBanErrCode.ERR_1, pageResult2);
    }
    
    /**
     * 素材查询
     * @return
     */
    @RequestMapping("/material-type")
    public HaobanResponse materialType(String wxEnterpriseId) {
    	List<MaterialCategoryDTO> list = materialApiService.listCategory(wxEnterpriseId);
    	List<MaterialVO> handerList = new ArrayList<MaterialVO>();
    	MaterialVO vo = new MaterialVO();
    	vo.setCategoryId("-1");
    	vo.setCategoryName("未分组");
    	vo.setCategoryParentId("0");
    	vo.setWxEnterpriseId(wxEnterpriseId);
    	handerList.add(vo);
    	for (MaterialCategoryDTO materialCategoryDTO : list) {
			if("0".equals(materialCategoryDTO.getCategoryParentId())){
				handerList.add(EntityUtil.changeEntityByJSON(MaterialVO.class, materialCategoryDTO));
			}
		}
    	Map<String,List<MaterialCategoryDTO>> map = list.stream().collect(Collectors.groupingBy(MaterialCategoryDTO::getCategoryParentId));
    	handerSonMaterial(handerList, map);
    	return resultResponse(HaoBanErrCode.ERR_1,handerList);
    }
    
    private void handerSonMaterial(List<MaterialVO> handerList,Map<String,List<MaterialCategoryDTO>> map){
    	for (MaterialVO materialVO : handerList) {
			List<MaterialCategoryDTO> sonList = map.get(materialVO.getCategoryId());
			List<MaterialVO> sonVoList = EntityUtil.changeEntityListByJSON(MaterialVO.class, sonList);
			materialVO.setList(sonVoList);
			while(sonList != null && sonList.size() > 0){
				handerSonMaterial(sonVoList, map);
			}
    	}
    }

}
